
var MdxDictController = JSB.defineClass('MdxDictController : UIViewController', {
  viewDidLoad: function() {
    const headers = {
    "User-Agent":
      "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
    "Content-Type": "application/json",
    Accept: "application/json"
  }
  self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
  self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
  self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
  self.reloadImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/reload.png`), 2)
  self.stopImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
  self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)



  // let NDdict= NSDictionary.dictionaryWithObjectsAndKeys("UserAgent",'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15')

    let request = NSMutableURLRequest.requestWithURL(NSURL.URLWithString('https://useragent.buyaocha.com/'))
    // request.setAllHTTPHeaderFields(headers)
  //     NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (Linux; Android 4.2.1; M040 Build/JOP40D) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.59 Mobile Safari/537.36'});
  // NSUserDefaults.standardUserDefaults().removeObjectForKey("UserAgent")
  // NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (Linux; Android 4.2.1; M040 Build/JOP40D) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.59 Mobile Safari/537.36'});  
  // NSUserDefaults.standardUserDefaults().synchronize();
    // self.request = NSMutableURLRequest.requestWithURL(NSURL.URLWithString('https://useragent.buyaocha.com/'))
    // try {
    // request.setHTTPMethod("GET")
    // request.setValueForHTTPHeaderField('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"User-Agent")
    // } catch (error) {
    //   Application.sharedInstance().showHUD("error", self.view.window, 2);
    // }
    // NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36'});
    self.navigationItem.title = 'MdxDict Addon Pannel';
    // self.navigationItem.UserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36';
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.minimized = false;
    self.maximized = false
    self.miniMode = false;
    self.selectedText = '';
    self.engine = '🔍 Bing'
    self.isLoading = false;
    self.toolbarOn = true
    self.lastFrame = self.view.frame;
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    self.frame = self.view.frame;

    // >>> DeepL view >>>
    self.deeplView = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.deeplView.url = 'https://m.inftab.com/';
    self.deeplView.backgroundColor = UIColor.whiteColor();
    self.deeplView.scalesPageToFit = true;
    self.deeplView.autoresizingMask = (1 << 1 | 1 << 4);
    self.deeplView.delegate = self;
    // self.deeplView.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.deeplView.scrollView.delegate = self;
    self.deeplView.layer.cornerRadius = 15;
    self.deeplView.layer.masksToBounds = true;
    // self.deeplView.loadRequest(
    //   request
    // );
    self.deeplView.loadRequest(
      NSURLRequest.requestWithURL(NSURL.URLWithString(self.deeplView.url))
    );
    // self.updateOffset();
    var highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    self.deeplView.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.deeplView.hidden = true;
    self.deeplView.lastOffset = 0;
    // self.updateButton();
    self.view.addSubview(self.deeplView);
    // <<< DeepL view <<<

    // >>> opacity button >>>
    self.opacityButton = UIButton.buttonWithType(0);
    self.opacityButton.autoresizingMask = (1 << 0 | 1 << 3);
    self.opacityButton.setTitleForState('100%', 0);
    self.opacityButton.setTitleColorForState(UIColor.whiteColor(),0);
    self.opacityButton.setTitleColorForState(highlightColor, 1);
    self.opacityButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    self.opacityButton.layer.cornerRadius = 8;
    self.opacityButton.layer.masksToBounds = true;
    self.opacityButton.titleLabel.font = UIFont.systemFontOfSize(12);
    self.opacityButton.addTargetActionForControlEvents(self, "changeOpacity:", 1 << 6);
    self.view.addSubview(self.opacityButton);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.closeButton.autoresizingMask = (1 << 0 | 1 << 3);
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.setTitleColorForState(
      Application.sharedInstance().defaultTintColorForDarkBackground,
      0
    );
    self.closeButton.setTitleColorForState(highlightColor, 1);
    self.closeButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.6);
    self.closeButton.layer.cornerRadius = 10;
    self.closeButton.layer.masksToBounds = true;
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    self.closeButton.addTargetActionForControlEvents(self, "closeButtonTapped:", 1 << 6);
    self.view.addSubview(self.closeButton);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.maxButton.autoresizingMask = (1 << 0 | 1 << 3);
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.setTitleColorForState(
      Application.sharedInstance().defaultTintColorForDarkBackground,
      0
    );
    self.maxButton.setTitleColorForState(highlightColor, 1);
    self.maxButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.6)
    self.maxButton.layer.cornerRadius = 10;
    self.maxButton.layer.masksToBounds = true;
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    self.maxButton.addTargetActionForControlEvents(self, "maxButtonTapped:", 1 << 6);
    self.view.addSubview(self.maxButton);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.screenButton.autoresizingMask = (1 << 3);
    // self.screenButton.setTitleForState('Screen', 0);
    self.screenButton.setTitleColorForState(highlightColor, 1);
    self.screenButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
    self.screenButton.layer.cornerRadius = 8;
    self.screenButton.layer.masksToBounds = true;
    self.screenButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    self.screenButton.setImageForState(self.screenImage,0)
    self.screenButton.addTargetActionForControlEvents(self, 'changeScreen:', 1 << 6);
    self.view.addSubview(self.screenButton);
    // <<< screen button <<<
    // >>> engine button >>>
    self.engineButton = UIButton.buttonWithType(0);
    self.engineButton.autoresizingMask = (1 << 3);
    self.engineButton.setTitleForState('Bing', 0);
    self.engineButton.setTitleColorForState(
      UIColor.whiteColor(),
      0
    );
    self.engineButton.setTitleColorForState(highlightColor, 1);
    self.engineButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
    self.engineButton.layer.cornerRadius = 8;
    self.engineButton.layer.masksToBounds = true;
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    self.engineButton.addTargetActionForControlEvents(self, 'changeEngine:', 1 << 6);
    self.view.addSubview(self.engineButton);
    // <<< engine button <<<
        // >>> home button >>>
    self.homeButton = UIButton.buttonWithType(0);
    self.homeButton.autoresizingMask = (1 << 0 | 1 << 3);
    // self.homeButton.setTitleForState('🌐', 0);
    self.homeButton.setTitleColorForState(highlightColor, 1);
    self.homeButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    self.homeButton.layer.cornerRadius = 8;
    self.homeButton.layer.masksToBounds = true;
    // self.homeButton.titleLabel.font = UIFont.systemFontOfSize(15);
    self.homeButton.addTargetActionForControlEvents(self, "homeButtonTapped:", 1 << 6);
    self.homeButton.setImageForState(self.homeImage,0)
    self.view.addSubview(self.homeButton);
    // <<< home button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.searchButton.autoresizingMask = (1 << 0 | 1 << 3);
    self.searchButton.setTitleForState('🔍', 0);
    self.searchButton.setTitleColorForState(highlightColor, 1);
    self.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    self.searchButton.layer.cornerRadius = 8;
    self.searchButton.layer.masksToBounds = true;
    self.searchButton.titleLabel.font = UIFont.systemFontOfSize(15);
    self.searchButton.addTargetActionForControlEvents(self, "searchButtonTapped:", 1 << 6);
    self.view.addSubview(self.searchButton);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.moveButton.autoresizingMask = (1 << 3);
    self.moveButton.setTitleColorForState(
      Application.sharedInstance().defaultTintColorForDarkBackground,
      0
    );
    self.moveButton.setTitleColorForState(highlightColor, 1);
    self.moveButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
    self.moveButton.layer.cornerRadius = 5;
    self.moveButton.layer.masksToBounds = true;
    self.moveButton.titleLabel.font = UIFont.systemFontOfSize(14);
    // self.moveButton.addTargetActionForControlEvents(self, 'changemove:', 1 << 6);
    self.view.addSubview(self.moveButton);
    // <<< move button <<<
    //  Application.sharedInstance().showHUD('DeepL加载失败，请检查网络后重试', self.view.window, 2);
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.goForwardButton.autoresizingMask = (1 << 0 | 1 << 3);
    // self.goForwardButton.setTitleForState('↪️', 0);
    self.goForwardButton.setTitleColorForState(highlightColor, 1);
    self.goForwardButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
    self.goForwardButton.layer.cornerRadius = 8;
    self.goForwardButton.layer.masksToBounds = true;
    // self.goForwardButton.titleLabel.font = UIFont.systemFontOfSize(14);
    self.goForwardButton.addTargetActionForControlEvents(self, "goForwardButtonTapped:", 1 << 6);
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    self.view.addSubview(self.goForwardButton);
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.goBackButton.autoresizingMask = (1 << 0 | 1 << 3);
    // self.goBackButton.setTitleForState('↩️', 0);
    self.goBackButton.setTitleColorForState(highlightColor, 1);
    self.goBackButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
    self.goBackButton.layer.cornerRadius = 8;
    self.goBackButton.layer.masksToBounds = true;
    // self.goBackButton.titleLabel.font = UIFont.systemFontOfSize(14);
    self.goBackButton.addTargetActionForControlEvents(self, "goBackButtonTapped:", 1 << 6);
    self.goBackButton.setImageForState(self.gobackImage,0)
    self.view.addSubview(self.goBackButton);
    // <<< goBack button <<<
    // >>> refresh button >>>
    self.refreshButton = UIButton.buttonWithType(0);
    self.refreshButton.autoresizingMask = (1 << 0 | 1 << 3);
    // self.refreshButton.setTitleForState('🔄', 0);
    self.refreshButton.setTitleColorForState(highlightColor, 1);
    self.refreshButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8)
    self.refreshButton.layer.cornerRadius = 8;
    self.refreshButton.layer.masksToBounds = true;
    // self.refreshButton.titleLabel.font = UIFont.systemFontOfSize(14);
    self.refreshButton.addTargetActionForControlEvents(self, "refreshButtonTapped:", 1 << 6);
    self.refreshButton.setImageForState(self.reloadImage,0)
    self.view.addSubview(self.refreshButton);
    // <<< refresh button <<<
    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    self.deeplView.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.deeplView.stopLoading();
    self.deeplView.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
  viewWillLayoutSubviews: function() {
    if (self.miniMode) {
      return
    }

    var viewFrame = self.view.bounds;
    self.closeButton.frame = {
      x: viewFrame.x + viewFrame.width-17,
      y: viewFrame.y + 3,
      width: 18,
      height: 18,
    };
    self.maxButton.frame = {
      x: viewFrame.x + viewFrame.width-40,
      y: viewFrame.y + 3,
      width: 18,
      height: 18,
    };
    if (self.toolbarOn) {
      self.screenButton.frame = {
        x: viewFrame.x + viewFrame.width - 40,
        y: viewFrame.y + viewFrame.height - 25,
        width: 40,
        height: 25,
      };
    }else{
      self.screenButton.frame = {
        x: viewFrame.x + viewFrame.width - 40,
        y: viewFrame.y + viewFrame.height - 20,
        width: 33,
        height: 25,
      };
    }
    self.engineButton.frame = {
      x: viewFrame.x + viewFrame.width - 105,
      y: viewFrame.y + viewFrame.height - 25,
      width: 60,
      height: 25,
    };


    if (viewFrame.width <= 300) {
      self.moveButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-75,
        y: viewFrame.y + 5,
        width: viewFrame.width*0.5,
        height: 10,
      };
        self.refreshButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.engineButton.hidden = true
      self.homeButton.frame = {
        x: viewFrame.x + (viewFrame.width-200)*0.8+43,
        y: viewFrame.y + viewFrame.height - 25,
        width: 49,
        height: 25,
      };    
      if (self.toolbarOn) {
        self.searchButton.frame = {
          x: viewFrame.x + (viewFrame.width-200)*0.8+100,
          y: viewFrame.y + viewFrame.height - 25,
          width: 49,
          height: 25,
        };
      }else{
        self.searchButton.frame = {
          x: viewFrame.x + viewFrame.width - 75,
          y: viewFrame.y + viewFrame.height - 20,
          width: 30,
          height: 25,
        };
      }
      self.opacityButton.frame = {
        x: viewFrame.x + (viewFrame.width-200)*0.8,
        y: viewFrame.y + viewFrame.height - 25,
        width: 35,
        height: 25,
      };
    }else{
      self.moveButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-75,
        y: viewFrame.y + 5,
        width: 150,
        height: 10,
      };
      if (self.toolbarOn) {
        self.refreshButton.hidden = false
        self.goBackButton.hidden = false
        self.goForwardButton.hidden = false
        self.engineButton.hidden = false
      }
      self.homeButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-35,
        y: viewFrame.y + viewFrame.height - 25,
        width: 49,
        height: 25,
      };    
      if (self.toolbarOn) {
        self.searchButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5+19,
          y: viewFrame.y + viewFrame.height - 25,
          width: 49,
          height: 25,
        };
      }else{
        self.searchButton.frame = {
          x: viewFrame.x + viewFrame.width - 75,
          y: viewFrame.y + viewFrame.height - 20,
          width: 30,
          height: 25,
        };
      }
      self.opacityButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-75,
        y: viewFrame.y + viewFrame.height - 25,
        width: 35,
        height: 25,
      };
    }
    self.goBackButton.frame = {
      x: viewFrame.x,
      y: viewFrame.y + viewFrame.height - 25,
      width: 30,
      height: 25,
    };
    self.goForwardButton.frame = {
      x: viewFrame.x+36,
      y: viewFrame.y + viewFrame.height - 25,
      width: 30,
      height: 25,
    };
    self.refreshButton.frame = {
      x: viewFrame.x + 72,
      y: viewFrame.y + viewFrame.height - 25,
      width: 30,
      height: 25,
    };
    if (self.toolbarOn) {
      self.deeplView.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
    }else{
      self.deeplView.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
    }
    var deeplViewFrame = self.deeplView.bounds;
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
    // self.changeUA()
    let currentURL = webView.request.URL().absoluteString();
    // Application.sharedInstance().showHUD(currentURL, self.view.window, 5);
    if (/^marginnote3app/.test(currentURL)) {
      Application.sharedInstance().openURL(NSURL.URLWithString(currentURL));
      webView.stopLoading();
      return
    }

    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    // self.screenButton.setTitleForState('Loading', 0);

    if (self.engine === "📝 Craft" || self.engine === "📝 Notion") {
      return;
    }
    self.refreshButton.setImageForState(self.stopImage,0)
    // self.refreshButton.setTitleForState('✖️', 0);
    self.opacityButton.layer.opacity = 0.5
    self.searchButton.layer.opacity = 0.5
    self.homeButton.layer.opacity = 0.5
    self.goBackButton.layer.opacity = 0.5
    self.goForwardButton.layer.opacity = 0.5
    self.refreshButton.layer.opacity = 0.5
    self.screenButton.layer.opacity = 0.5
    self.engineButton.layer.opacity = 0.5
    self.moveButton.layer.opacity = 0.5
    self.maxButton.layer.opacity = 0.5
    self.closeButton.layer.opacity = 0.5
    self.isLoading = true;

    // if (self.engine === "📝 Deepl") {
    //   self.updateDeeplOffset()
    // }
    // if (self.engine === "📝 Baidu") {
    //   self.updateBaiduOffset()
    // }
    // if (self.engine === "🔍 ResearchGate") {
    //   self.updateRGOffset()
    // }
  },
  webViewDidFinishLoad: function(webView) {
    // self.changeUA()
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    // self.getCurrentURL(webView)
    // let currentURL = webView.request.URL().absoluteString();
    self.deeplView.url = webView.request.URL().absoluteString();
    // self.screenButton.setTitleForState('Screen', 0);
    if (self.engine === "📔 Craft" || self.engine === "📔 Notion") {
      return;
    }
    self.refreshButton.setImageForState(self.reloadImage,0)

    // self.refreshButton.setTitleForState('🔄', 0);
    self.opacityButton.layer.opacity = 1.0
    self.searchButton.layer.opacity = 1.0
    self.homeButton.layer.opacity = 1.0
    self.goBackButton.layer.opacity = 1.0
    self.goForwardButton.layer.opacity = 1.0
    self.refreshButton.layer.opacity = 1.0
    self.screenButton.layer.opacity = 1.0
    self.engineButton.layer.opacity = 1.0
    self.moveButton.layer.opacity = 1.0
    self.maxButton.layer.opacity = 1.0
    self.closeButton.layer.opacity = 1.0
    self.isLoading = false;
    switch (self.engine) {
      case "📔 Deepl":
        self.updateDeeplOffset()
        break;
      case "📔 Baidu":
        self.updateBaiduOffset()
        break;
      case "🎓 ResearchGate":
        self.updateRGOffset()
        break;
      case "🔍 Bing":
        self.updateBingOffset()
        break;
      default:
        break;
    }
    // self.currentURL = webView.request.URL.absoluteString;
    //  Application.sharedInstance().showHUD(self.deeplView.url, self.view.window, 2);

    //  Application.sharedInstance().showHUD(Object.getOwnPropertyNames(webView.url), self.view.window, 2);
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
  webViewDidFailLoadWithError: function(webView, error) {
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.opacityButton.layer.opacity = 1.0
    self.searchButton.layer.opacity = 1.0
    self.homeButton.layer.opacity = 1.0
    self.goBackButton.layer.opacity = 1.0
    self.goForwardButton.layer.opacity = 1.0
    self.refreshButton.layer.opacity = 1.0
    self.screenButton.layer.opacity = 1.0
    self.engineButton.layer.opacity = 1.0
    self.moveButton.layer.opacity = 1.0
    self.maxButton.layer.opacity = 1.0
    self.closeButton.layer.opacity = 1.0
    self.isLoading = false;
    self.getCurrentURL()
    //UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    //var lan = NSLocale.preferredLanguages() ? NSLocale.preferredLanguages()[0].substring(0,2) : 'en';
    //if (lan == 'zh') {
    //  Application.sharedInstance().showHUD('错误', self.view.window, 2);
    //} else {
    //  Application.sharedInstance().showHUD('Failed to load DeepL translator, please try again later', self.view.window, 2);
    //}
  },
  // webViewShouldStartLoadWithRequestNavigationType: function (test=0,test0=0,test1=0,test2=0) {
  //    Application.sharedInstance().showHUD('错误', self.view.window, 2);
  //   return true
  // },
  changeScreen: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🌟 Dynamic',object:self,selector:'dynamicButtonTapped:',param:'right',checked:self.dynamic},
      {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:self.toolbarOn},

    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeEngine: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'🔍 Bing',object:self,selector:'searchWithEngine:',param:'🔍 Bing',checked:self.engine==='🔍 Bing'},
      {title:'🔍 Zhihu',object:self,selector:'searchWithEngine:',param:'🔍 Zhihu',checked:self.engine==='🔍 Zhihu'},
      {title:'🔍 Baidu',object:self,selector:'searchWithEngine:',param:'🔍 Baidu',checked:self.engine==='🔍 Baidu'},
      {title:'🔍 Google',object:self,selector:'searchWithEngine:',param:'🔍 Google',checked:self.engine==='🔍 Google'},
      {title:'🔍 Yandex',object:self,selector:'searchWithEngine:',param:'🔍 Yandex',checked:self.engine==='🔍 Yandex'},
      {title:'🔍 Sougou',object:self,selector:'searchWithEngine:',param:'🔍 Sougou',checked:self.engine==='🔍 Sougou'},
      {title:'🔍 Wikipedia',object:self,selector:'searchWithEngine:',param:'🔍 Wikipedia',checked:self.engine==='🔍 Wikipedia'},
      {title:'📔 Baidu',object:self,selector:'searchWithEngine:',param:'📔 Baidu',checked:self.engine==='📔 Baidu'},
      {title:'📔 Deepl',object:self,selector:'searchWithEngine:',param:'📔 Deepl',checked:self.engine==='📔 Deepl'},
      {title:'📔 Google',object:self,selector:'searchWithEngine:',param:'📔 Google',checked:self.engine==='📔 Google'},
      {title:'📝 Notion',object:self,selector:'searchWithEngine:',param:'📝 Notion',checked:self.engine==='📝 Notion'},
      {title:'📝 Wolai',object:self,selector:'searchWithEngine:',param:'📝 Wolai',checked:self.engine==='📝 Wolai'},
      {title:'📝 Craft',object:self,selector:'searchWithEngine:',param:'📝 Craft',checked:self.engine==='📝 Craft'},
      {title:'📝 Flomo',object:self,selector:'searchWithEngine:',param:'📝 Flomo',checked:self.engine==='📝 Flomo'},
      {title:'📝 Flowus',object:self,selector:'searchWithEngine:',param:'📝 Flowus',checked:self.engine==='📝 Flowus'},
      {title:'☁️ Baidu',object:self,selector:'searchWithEngine:',param:'☁️ Baidu',checked:self.engine==='☁️ Baidu'},
      {title:'🎓 ResearchGate',object:self,selector:'searchWithEngine:',param:'🎓 ResearchGate',checked:self.engine==='🎓 ResearchGate'},
      {title:'🎓 Google Scholar',object:self,selector:'searchWithEngine:',param:'🎓 Google Scholar',checked:self.engine==='🎓 Google Scholar'},
      {title:'🌐 Open in browser',object:self,selector:'openInBrowser:',param:'right'},
      {title:'🌐 Copy link',object:self,selector:'copyCurrentURL:',param:'right'},
      {title:'🌐 Open copied link',object:self,selector:'openCopiedURL:',param:'right'}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    self.opacityButton.setTitleForState(`${opacity*100}%`, 0);
  },
  toggleToolbar:function (opacity) {
    self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.toolbarOn,self.view.window,2)
    self.toolbarOn = !self.toolbarOn
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.toolbarOn, 'MNBrowser_toolbar');
    self.opacityButton.hidden = !self.toolbarOn
    // self.searchButton.hidden = !self.toolbarOn
    self.homeButton.hidden = !self.toolbarOn
    self.goBackButton.hidden = !self.toolbarOn
    self.goForwardButton.hidden = !self.toolbarOn
    self.refreshButton.hidden = !self.toolbarOn
    // self.screenButton.hidden = !self.toolbarOn
    self.engineButton.hidden = !self.toolbarOn
    var viewFrame = self.view.bounds;
    if (self.toolbarOn) {
      self.deeplView.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
    }else{
      self.deeplView.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
    }
  },

  searchWithEngine: function (engine) {
    self.engine = engine
    NSUserDefaults.standardUserDefaults().setObjectForKey(engine, 'MNBrowser_engine');
    self.search(self.selectedText)
    self.view.popoverController.dismissPopoverAnimated(true);
  },
  openInBrowser: function (engine) {
    Application.sharedInstance().openURL(NSURL.URLWithString(self.deeplView.url));
  },
  copyCurrentURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    pasteBoard.string = self.deeplView.url
    // Application.sharedInstance().showHUD(self.deeplView.url,self.view.window,2)

    // Application.sharedInstance().openURL(NSURL.URLWithString(self.deeplView.url));
  },
  openCopiedURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    self.deeplView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(pasteBoard.string)));
    // Application.sharedInstance().openURL(NSURL.URLWithString(self.deeplView.url));
  },
  homeButtonTapped: function() {
    if (self.minimized) {
      self.minimized = false
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.deeplView.hidden = false
    }
    self.homePage('')
  },
  searchButtonTapped: function() {
    // self.switchView();
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.deeplView.hidden = false
    }
    // self.deeplView.goBack();
    self.search(self.selectedText)
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  goBackButtonTapped: function() {
    // self.switchView();
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.deeplView.hidden = false
    }
    self.deeplView.goBack();
    // self.search('')
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  goForwardButtonTapped: function() {
    // self.switchView();
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.deeplView.hidden = false
    }
    self.deeplView.goForward();
    // self.search('')
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  refreshButtonTapped: function(para) {

    if (self.isLoading) {
      self.deeplView.stopLoading();
      // self.screenButton.setTitleForState('Screen', 0);
      // self.refreshButton.setTitleForState('🔄', 0);
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.opacityButton.layer.opacity = 1.0
      self.searchButton.layer.opacity = 1.0
      self.homeButton.layer.opacity = 1.0
      self.goBackButton.layer.opacity = 1.0
      self.goForwardButton.layer.opacity = 1.0
      self.refreshButton.layer.opacity = 1.0
      self.screenButton.layer.opacity = 1.0
      self.engineButton.layer.opacity = 1.0
      self.moveButton.layer.opacity = 1.0
      self.maxButton.layer.opacity = 1.0
      self.closeButton.layer.opacity = 1.0
      self.isLoading = false;
    }else{
      self.deeplView.reload();
    }
    // self.search('')
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  dynamicButtonTapped: function() {
    self.view.popoverController.dismissPopoverAnimated(true);
    // self.switchView();
    self.dynamic = true;
    self.custom = false;
    self.customMode = "None"
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.deeplView.hidden = false
      self.moveButton.hidden = false
      self.maxButton.hidden = false
      self.closeButton.hidden = false
    }
    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  closeButtonTapped: function() {
    // self.switchView();
    self.view.hidden = true;
    // self.custom = false;
    // self.minimized = false;
    // self.dynamic = true;

    if ( self.currentView = "deepl") {
      var url = 'https://inftab.com/'
      // var url = 'https://www.bilibili.com/online.html'
      self.deeplView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
    }
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('close', self.view.window, {test:123})
  },
  minButtonTapped: function() {
  // Application.sharedInstance().showHUD('textSelected',self.view.window,2)
  // try {
    // NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('trst', self.view.window, {test:123})
  // } catch (error) {
  //   Application.sharedInstance().showHUD(error,self.view.window,2)
    
  // }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:0,y:frame.height-60,width:100,height:45}
    self.moveButton.hidden = true
    self.minButton.hidden = true
    self.maxButton.hidden = true
    self.closeButton.hidden = true
    // Application.sharedInstance().showHUD('minimize',self.view.window,2)
    self.minimized = true
    self.dynamic = false;
    self.deeplView.hidden = true



    // Application.sharedInstance().showHUD("watch mode: "+self.watchMode,self.window,2)
    // self.watchButton.setTitleForState('1', 0);
  },
  leftButtonTapped: function() {
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.minimized = false
    self.dynamic = false;
    self.deeplView.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    self.customMode = "left13"
    self.minimized = false
    self.dynamic = false;
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.deeplView.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    self.customMode = "right"
    self.minimized = false
    self.dynamic = false;
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.deeplView.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    self.custom = true;
    self.customMode = "right13"
    self.minimized = false
    self.dynamic = false;
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.deeplView.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.maximized) {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      self.maximized = false
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.minimized = false
    self.maximized = true
    self.dynamic = false;
    self.deeplView.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let translationX = locationInView.x - baseframe.width*0.5
    let translationY = locationInView.y - baseframe.height*0.5
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = Application.sharedInstance().studyController(self.view.window).view.bounds
    let y = frame.y+translationY
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = frame.x+translationX
    if (!self.miniMode) {
      if (x+frame.width*0.5-40<0) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.deeplView.hidden = true
        self.view.frame = {
          x:0,
          y:frame.y,
          width:40,
          height:40
        }
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.engineButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (x>studyFrame.width-frame.width*0.5-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.deeplView.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.engineButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.refreshButton.hidden = true
        self.opacityButton.hidden = true
        self.searchButton.hidden = true
        self.homeButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (x+frame.width*0.5-50<=0) {
        x = -frame.width*0.5+20
      }else if (x>studyFrame.width-frame.width*0.5-50) {
        x = studyFrame.width-40
      }else{
        self.view.frame = {
          x:40,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        viewFrame = self.view.bounds;
        self.miniMode = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.deeplView.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        if (self.toolbarOn) {
          self.homeButton.hidden = false
          self.engineButton.hidden = false
          self.opacityButton.hidden = false
        }

        return
      }
    }

    // if (x>studyFrame.width-frame.width*0.5+50) {
    //   x=studyFrame.width-frame.width*0.5+50
    // }

    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
     self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
    // if (gesture.state === "begin") {
      
    // }
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
     self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}

    // if (gesture.state === "begin") {
      
    // }
  }
});
MdxDictController.prototype.lookup = function(text) {
  this.text = text.replace(/^\s+/, '').replace(/\s+$/, '');//去除前后空格
  this.mdxDictView.evaluateJavaScript(`$("#definition").empty();$("#word").val("${this.text}");$("#btn").click();`, res => {});
  if (/^(\b\w+\b\s?){1,3}$/.test(this.text)) { // when text consists of up to 3 words, await lookup result
    NSTimer.scheduledTimerWithTimeInterval(0.1, false, () => {
      this.mdxDictView.evaluateJavaScript('document.lookupStatus;', res => {
        if (Number(res)&&this.mdxDictView.hidden || !Number(res)&&!this.mdxDictView.hidden) {this.switchView();} // switch to DeepL view when lookup fails
      });
    });
    this.currentView = "mdx"
  } else { // switch to DeepL view when text consists of at least 4 words
    if (this.deeplView.hidden) {this.switchView();}
    this.currentView = "deepl"
  }
};

MdxDictController.prototype.homePage = function(text) {
  var url = 'https://m.inftab.com/'
  // var url = 'https://useragent.buyaocha.com/'
  this.deeplView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
  this.deeplView.lanButton.hidden = true
  this.deeplView.hidden = false
  this.currentView = "deepl"
  // var url = `${this.deeplView.url}#en/${this.deeplView.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
  this.changeUA();
};

MdxDictController.prototype.search = function(text) {
  // NSUserDefaults.standardUserDefaults().synchronize();
  // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    //  Application.sharedInstance().showHUD(text, this.view.window, 2);
  var url;
  switch (this.engine) {
    case '🔍 Bing':
      // url = `https://www.notion.so`
      url = `https://www.bing.com/search?q=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Bing", 0);
      break;
    case '🔍 Baidu':
      url = `https://www.baidu.com/s?wd=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Baidu", 0);
      break;
    case '🔍 Google':
      url = `https://www.google.com/search?q=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Google", 0);
      break;
    case '🔍 Sougou':
      url = `https://www.sogou.com/web?query=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Sougou", 0);
      break;
    case '🔍 Wikipedia':
      url = `hhttps://www.wikipedia.org/w/index.php?search=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Wikipedia", 0);
      break;
    case '🎓 Google Scholar':
      url = `https://scholar.google.com/scholar?q=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🎓', 0);
      this.engineButton.setTitleForState("Scholar", 0);
      break;
    case '🎓 ResearchGate':
      url = `https://www.researchgate.net/search.Search.html?query=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🎓', 0);
      this.engineButton.setTitleForState("RG", 0);
      break;
    case '🔍 Zhihu':
      url = `https://www.zhihu.com/search?type=content&q=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Zhihu", 0);
      break;
    case '🔍 Yandex':
      url = `https://yandex.com/search/?text=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('🔍', 0);
      this.engineButton.setTitleForState("Yandex", 0);
      break;
    case '📔 Deepl':
      url = `https://www.deepl.com/translator#en/zh/${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('📔', 0);
      this.engineButton.setTitleForState("Deepl", 0);
      break;
    case '📔 Baidu':
      url = `https://fanyi.baidu.com/#en/zh/${encodeURIComponent(text.replaceAll('/', '\\/'))}`
      this.searchButton.setTitleForState('📔', 0);
      this.engineButton.setTitleForState("Baidu", 0);
      break;
    case '📔 Google':
      url = `https://translate.google.com/?sl=en&tl=zh-CN&text=${encodeURIComponent(text.replaceAll('/', '\\/'))}&op=translate`
      this.searchButton.setTitleForState('📔', 0);
      this.engineButton.setTitleForState("Google", 0);
      break;
    case '📝 Notion':
      url = `https://www.notion.so`
      this.searchButton.setTitleForState('📝', 0);
      this.engineButton.setTitleForState("Notion", 0);
      break;
    case '📝 Wolai':
      url = `https://www.wolai.com`
      this.searchButton.setTitleForState('📝', 0);
      this.engineButton.setTitleForState("Wolai", 0);
      break;
    case '📝 Craft':
      url = `https://docs.craft.do`
      this.searchButton.setTitleForState('📝', 0);
      this.engineButton.setTitleForState("Craft", 0);
      break;
    case '📝 Flomo':
      url = `https://v.flomoapp.com/mine`
      this.searchButton.setTitleForState('📝', 0);
      this.engineButton.setTitleForState("Flomo", 0);
      break;
    case '📝 Flowus':
      url = `https://flowus.cn`
      this.searchButton.setTitleForState('📝', 0);
      this.engineButton.setTitleForState("Flowus", 0);
      break;
    case '☁️ Baidu':
      // url = `https://flowus.cn`
      url = `https://pan.baidu.com/disk/main#/index?category=all`
      this.searchButton.setTitleForState('☁️', 0);
      this.engineButton.setTitleForState("Baidu", 0);
      break;
    default:
      break;
  }
  // var url = `https://www.bing.com/search?q=${encodeURIComponent(text.replaceAll('/', '\\/'))}`
    // let request = NSMutableURLRequest.requestWithURL(NSURL.URLWithString('https://tool.ip138.com/useragent/'))
    // self.request = NSMutableURLRequest.requestWithURL(NSURL.URLWithString('https://tool.ip138.com/useragent/'))
    // try {
  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Linux; Android 4.2.1; M040 Build/JOP40D) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.59 Mobile Safari/537.36",
    "Content-Type": "application/x-www-form-urlencoded"  }
    // request.setAllHTTPHeaderFields(headers)
    // request.setHTTPMethod("GET")
    // request.setURL(NSURL.URLWithString(url))
    // try {
    // request.setValueForHTTPHeaderField("User-Agent",'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15')
    // request.setValueForHTTPHeaderField('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"User-Agent")
    // // request.setValueForHTTPHeaderField('2',"Refresh")
      
    // } catch (error) {
    //  Application.sharedInstance().showHUD(error, self.view.window, 2);
      
    // }
    //  Application.sharedInstance().showHUD(request.valueForHTTPHeaderField("device"), self.view.window, 2);
  if (this.deeplView.url !== url) {
    this.deeplView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
  }
  // this.deeplView.loadRequest(request);
    //  Application.sharedInstance().showHUD(request.valueForHTTPHeaderField("User-Agent"), self.view.window, 2);
  this.deeplView.hidden = false
  // this.changeUA();
  // var url = `${this.deeplView.url}#en/${this.deeplView.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
  
};

MdxDictController.prototype.switchView = function() {
    this.deeplView.hidden = !this.mdxDictView.hidden;
};

MdxDictController.prototype.updateButton = function() {
  if(this.deeplView.lanCode == 'en')
    this.deeplView.lanButton.setTitleForState('English',0);
  else if(this.deeplView.lanCode == 'zh')
    this.deeplView.lanButton.setTitleForState('Chinese',0);
  else if(this.deeplView.lanCode == 'ja')
    this.deeplView.lanButton.setTitleForState('Japanese',0);
  else if(this.deeplView.lanCode == 'de')
    this.deeplView.lanButton.setTitleForState('German',0);
  else if(this.deeplView.lanCode == 'fr')
    this.deeplView.lanButton.setTitleForState('French',0);
  else if(this.deeplView.lanCode == 'es')
    this.deeplView.lanButton.setTitleForState('Spanish',0);
  else if(this.deeplView.lanCode == 'ru')
    this.deeplView.lanButton.setTitleForState('Russian',0);
  else if(this.deeplView.lanCode == 'it')
    this.deeplView.lanButton.setTitleForState('Italian',0);
};

MdxDictController.prototype.updateDeeplOffset = function() {
  if(!this.deeplView || !this.deeplView.window)return;
  if (Application.sharedInstance().osType !== 1) {
    this.deeplView.evaluateJavaScript(
      `document.getElementsByClassName("dl_header")[0].style.display="none";
       document.getElementsByClassName("lmt__docTrans-tab-container")[0].style.display="none";
       document.getElementsByClassName("lmt__sides_container")[0].style.margin = 0;
       document.querySelector("#dl_translator").style.cssText = "padding-top: 20px";
       document.getElementsByClassName("lmt__language_container")[0].style.display = "none";
       document.getElementsByClassName("lmt__language_container")[1].style.display = "none";
       document.getElementsByClassName("lmt__target_toolbar")[0].style.display = "none";
       document.querySelector("#dl_cookieBanner").style.display="none";
       document.querySelector("#lmt_quotes_article").style.display="none";
       document.querySelector("#lmt__dict").style.margin = 0;
       document.querySelector("#lmt_pro_ad_container").style.display = "none";
       document.querySelector("body > div.dl_footerV2_container").style.display = "none";`,
      (ret) => {}
    );
  } else {
    this.deeplView.evaluateJavaScript(
      `document.querySelector("#gatsby-focus-wrapper > header").style.display = "none";
       document.querySelector("#gatsby-focus-wrapper > footer").style.display = "none";
       document.getElementsByClassName("TranslatorPage-module--otherSections--3cbQ7")[0].style.display = "none";`,
      (ret) => {}
    );
  }
  this.deeplView.evaluateJavaScript(
    'document.getElementsByClassName("lmt__side_container--target")[0].getBoundingClientRect().top + document.body.scrollTop+document.documentElement.scrollTop;',
    function (ret) {
      if (!this.deeplView) return;
      if (ret && !isNaN(parseFloat(ret))) {
        this.deeplView.scrollView.contentOffset = {x: 0, y: parseFloat(ret) + 0};          
      } else {
        this.deeplView.scrollView.contentOffset = {x: 0, y: 130};          
      }
    }
  );
};

MdxDictController.prototype.updateBaiduOffset = function() {
  if(!this.deeplView || !this.deeplView.window)return;
  this.deeplView.evaluateJavaScript(
    `document.getElementsByClassName("new-header")[0].style.display = "none";`,
    (ret) => {}
  );
};

MdxDictController.prototype.updateBingOffset = function() {
  if(!this.deeplView || !this.deeplView.window)return;
    this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.5, true, () => {
        this.deeplView.evaluateJavaScript(
          `document.getElementsByClassName("bottom bnp_rich_div_visible")[0].style.display = "none"
          var customUserAgent = 'Mozilla/5.0 (Linux; U; Android 7.0; zh-CN; PRO 7-S Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.2.46 Mobile Safari/537.36 AliApp(DingTalk/4.6.29) com.alibaba.android.rimet/11388461 Channel/10002068 language/zh-CN';
 
//修改后的userAgent            
            Object.defineProperty(navigator, 'userAgent', {
              value: customUserAgent,
              writable: false
            });
 
//打印
 
console.log(navigator.userAgent);`,
          (ret) => {}
        );
        this.viewTimer.invalidate();
    });

};

MdxDictController.prototype.updateRGOffset = function() {
  if(!this.deeplView || !this.deeplView.window)return;
  this.deeplView.evaluateJavaScript(
    `document.getElementsByClassName("header")[0].style.display = "none"`,
    (ret) => {}
  );
};

MdxDictController.prototype.getCurrentURL = function(webview) {
  if(!this.deeplView || !this.deeplView.window)return;
  this.deeplView.evaluateJavaScript(
    `window.location.href`,
    (ret) => {
      this.deeplView.url = ret
    }
  );
};

MdxDictController.prototype.changeUA = function() {

  if(!this.deeplView || !this.deeplView.window)return;
  this.deeplView.evaluateJavaScript(
        `var customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36';
            Object.defineProperty(navigator, 'userAgent', {
              value: customUserAgent,
              writable: false
            });
        `,
       
      (ret) => {}
  )
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }