
JSB.newAddon = function(mainPath) {
  JSB.require('MdxDictController');
  // let NDdict= NSDictionary.dictionaryWithObjectsAndKeys({UserAgent:'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15'})
  // NSUserDefaults.standardUserDefaults().removeObjectForKey("UserAgent")
  // NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/111.0.0.0 Safari/537.36 Edg/111.0.1661.59'});  
  // NSUserDefaults.standardUserDefaults().synchronize();
  let test = NSUserDefaults.standardUserDefaults().synchronize();
  var textSelected="";
  var temSender;
  var popUpOn = true;
  var currentNoteId;
  var textProcessed = false;
  var isOnSelection = false;
  var watchMode = false;
  var dateNow = Date.now();
  var dateGetText = Date.now();
  var newAddonClass = JSB.defineClass(
    'MdxDictAddon : JSExtension',
    { /* Instance members */
      sceneWillConnect: function() { //Window initialize
          self.appInstance = Application.sharedInstance();
          self.addonController = MdxDictController.new();
          self.addonController.mainPath = mainPath;
          self.selectionText = '';
          self.rect = '{{0, 0}, {10, 10}}';
          self.arrow = 1;
          // Application.sharedInstance().showHUD(engine,self.window,2)
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function() { // Window disconnect
      },

      sceneWillResignActive: function() { // Window resign active
      },

      sceneDidBecomeActive: function() { // Window become active
      },

      notebookWillOpen: function(notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.view.hidden = true;
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onCloseView:', 'close');
          let engine = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_engine');
          let toolbar = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_toolbar');
          if (engine) {
            self.addonController.engine = engine
            // Application.sharedInstance().showHUD(engine,self.window,2)
            switch (engine) {
              case '🔍 Bing':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Bing", 0);
                break;
              case '🔍 Baidu':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Baidu", 0);
                break;
              case '🔍 Google':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Google", 0);
                break;
              case '🔍 Sougou':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Sougou", 0);
                break;
              case '🔍 Wikipedia':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Wikipedia", 0);
                break;
              case '🎓 Google Scholar':
                self.addonController.searchButton.setTitleForState('🎓', 0);
                self.addonController.engineButton.setTitleForState("Scholar", 0);
                break;
              case '🎓 ResearchGate':
                self.addonController.searchButton.setTitleForState('🎓', 0);
                self.addonController.engineButton.setTitleForState("RG", 0);
                break;
              case '🔍 Zhihu':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Zhihu", 0);
                break;
              case '🔍 Yandex':
                self.addonController.searchButton.setTitleForState('🔍', 0);
                self.addonController.engineButton.setTitleForState("Yandex", 0);
                break;
              case '📔 Deepl':
                self.addonController.searchButton.setTitleForState('📔', 0);
                self.addonController.engineButton.setTitleForState("Deepl", 0);
                break;
              case '📔 Baidu':
                self.addonController.searchButton.setTitleForState('📔', 0);
                self.addonController.engineButton.setTitleForState("Baidu", 0);
                break;
              case '📔 Google':
                self.addonController.searchButton.setTitleForState('📔', 0);
                self.addonController.engineButton.setTitleForState("Google", 0);
                break;
              case '📝 Notion':
                self.addonController.searchButton.setTitleForState('📝', 0);
                self.addonController.engineButton.setTitleForState("Notion", 0);
                break;
              case '📝 Wolai':
                self.addonController.searchButton.setTitleForState('📝', 0);
                self.addonController.engineButton.setTitleForState("Wolai", 0);
                break;
              case '📝 Craft':
                self.addonController.searchButton.setTitleForState('📝', 0);
                self.addonController.engineButton.setTitleForState("Craft", 0);
                break;
              case '📝 Flomo':
                self.addonController.searchButton.setTitleForState('📝', 0);
                self.addonController.engineButton.setTitleForState("Flomo", 0);
                break;
              case '📝 Flowus':
                self.addonController.searchButton.setTitleForState('📝', 0);
                self.addonController.engineButton.setTitleForState("Flowus", 0);
                break;
              default:
                break;
            }
          }
          if (toolbar !== undefined) {
            self.addonController.toolbarOn = toolbar
            self.addonController.opacityButton.hidden = !toolbar
            // self.addonController.searchButton.hidden = !toolbar
            self.addonController.homeButton.hidden = !toolbarOn
            self.addonController.goBackButton.hidden = !toolbarOn
            self.addonController.goForwardButton.hidden = !toolbarOn
            self.addonController.refreshButton.hidden = !toolbarOn
            // self.addonController.screenButton.hidden = !toolbarOn
            self.addonController.engineButton.hidden = !toolbarOn
            var viewFrame = self.addonController.view.bounds;
            if (self.addonController.toolbarOn) {
              self.addonController.deeplView.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
            }else{
              self.addonController.deeplView.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
            }
          }
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function() { 
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      },

      notebookWillClose: function(notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        self.addonController.homePage('')
        // var url = 'https://inftab.com/'
        // self.addonController.deeplView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
        // self.addonController.view.removeFromSuperview();
        watchMode = false;
        textSelected = '';
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'ClosePopupMenuOnSelection');
      },

      documentDidOpen: function(docmd5) {
      },

      documentWillClose: function(docmd5) {
      },

      controllerWillLayoutSubviews: function(controller) {
        if (controller === self.appInstance.studyController(self.window)) {
        let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame

            // self.layoutAddonController();
            if (self.addonController.miniMode) {
                let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
                let height = studyFrame.height;
                let oldFrame = self.addonController.view.frame
                if (oldFrame.x < studyFrame.width) {
                  self.addonController.view.frame = {x:0,y:oldFrame.y,width:oldFrame.width,height:oldFrame.height}
                }else{
                  self.addonController.view.frame = {x:studyFrame.width-40,y:oldFrame.y,width:oldFrame.width,height:oldFrame.height}
                }
            }else if(self.addonController.custom){
              // Application.sharedInstance().showHUD(self.addonController.customMode,self.window,2)
              if (self.addonController.customMode === "left") {
                let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
                let height = studyFrame.height;
                let splitLine = getSplitLine()
                // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
                self.addonController.view.frame = {x:40,y:25,width:splitLine-45,height:height-35}
                // self.addonController.deeplView.frame = {x:0,y:0,width:splitLine-50,height:height-60}
                self.addonController.deeplView.frame = self.addonController.view.bounds

              }
              if (self.addonController.customMode === "left13") {
                let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
                let height = studyFrame.height;
                let splitLine = getSplitLine()
                // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
                self.addonController.view.frame = {x:40,y:25,width:studyFrame.width/3.+40,height:height-35}
                // self.addonController.deeplView.frame = {x:0,y:0,width:studyFrame.width/3.+40,height:height-60}
                self.addonController.deeplView.frame = self.addonController.view.bounds


              }
              if (self.addonController.customMode === "right") {

                let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
                let height = studyFrame.height;
                let splitLine = getSplitLine()
        // Application.sharedInstance().showHUD("x:"+splitLine+" x:"+(readerFrame.x+readerFrame.width),self.window,2)
                self.addonController.view.frame = {x:splitLine+5,y:25,width:studyFrame.width-splitLine-45,height:height-35}
                // self.addonController.deeplView.frame = {x:0,y:0,width:studyFrame.width-splitLine-50,height:height-60}
                self.addonController.deeplView.frame = self.addonController.view.bounds

                
              }
              if (self.addonController.customMode === "right13") {
                let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
                let height = studyFrame.height;
                self.addonController.view.frame = {x:studyFrame.width*2/3.-40,y:25,width:studyFrame.width/3.,height:height-30}
                self.addonController.deeplView.frame = self.addonController.view.bounds

                // self.addonController.deeplView.frame = {x:0,y:0,width:studyFrame.width/3.,height:height-60}
              }
              if (self.addonController.customMode === "full") {
                let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
                let height = studyFrame.height;
                self.addonController.view.frame = {x:40,y:25,width:studyFrame.width-80,height:height-35}
                self.addonController.deeplView.frame = self.addonController.view.bounds
                // self.addonController.deeplView.frame = {x:0,y:0,width:studyFrame.width-80,height:height-60}
              }
            } 
        }
      },

      queryAddonCommandStatus: function() {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: watchMode
          };
        } else {
          return null;
        }
      },

      onPopupMenuOnSelection: function(sender) { // Selecting text on pdf or epub
        isOnSelection = true
        textSelected = sender.userInfo.documentController.selectionText;
        // Application.sharedInstance().showHUD(textSelected,self.window,2)
        self.addonController.selectedText = textSelected
        dateGetText = Date.now();
        textProcessed = false
        temSender = sender
        if (!self.appInstance.checkNotifySenderInWindow(sender,self.window)) return; // Don't process message from other window
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!watchMode) {
          self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function() {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.viewTimer.invalidate()
          });
          return
        }
        var text = sender.userInfo.documentController.selectionText;
        if (text && text.length) {
          self.addonController.search(text);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.selectionText = text;
        }
      },

      onPopupMenuOnNote: function(sender) { // Clicking note
        isOnNote = true
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        // Application.sharedInstance().showHUD(frameText,self.window,5)
        currentNoteId = sender.userInfo.note.noteId
        // Application.sharedInstance().showHUD(self.addonController.watchMode,self.window,2)
        let note = Database.sharedInstance().getNoteById(sender.userInfo.note.noteId)
        // Application.sharedInstance().showHUD(note,self.window,2)
        textSelected = note.excerptText ?? note.noteTitle
        self.addonController.selectedText = textSelected
        dateGetText = Date.now();
        textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (!self.appInstance.checkNotifySenderInWindow(sender,self.window)) return; // Don't process message from other window
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!watchMode) {
          self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function() {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.viewTimer.invalidate()
          });
          return
        }
        if (textSelected && textSelected.length) {
          self.addonController.search(textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.selectionText = textSelected;
        }
        // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
      },
      onCloseView: function (params) {
        watchMode = false;
        self.appInstance.studyController(self.window).refreshAddonCommands();
        var url = 'https://inftab.com/'
        // var url = 'https://go.itab.link/'
        self.addonController.deeplView.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
      // custom = true;
          // self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);

          // self.customLayoutAddonController(123);
        // Application.sharedInstance().showHUD("trst",self.window,2)
        // try {
        // self.layoutAddonController(0,0,true)
          
        // } catch (error) {
        // Application.sharedInstance().showHUD(error,self.window,2)
          
        // }
      },
      toggleAddon: function(sender) {
        if (Date.now() - dateNow < 500) {
            watchMode = true;
            Application.sharedInstance().showHUD("watch mode",self.window,2)
            self.appInstance.studyController(self.window).refreshAddonCommands();
            return;
        }

        dateNow = Date.now();
          // NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
          // NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
          // popUpOn = true;
          if (self.addonController.view.hidden) {
            self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          }else{
            if (textProcessed || watchMode) {
              self.addonController.view.hidden = true;
              self.addonController.minimized= false
              self.addonController.miniMode = false
              watchMode = false;
              self.appInstance.studyController(self.window).refreshAddonCommands();
              return;
            }
          }
          // self.addonController.view.hidden = true;
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function() { 
            self.appInstance.studyController(self.window).becomeFirstResponder(); // For dismiss keyboard on iOS
          });
          if (!self.appInstance.checkNotifySenderInWindow(temSender,self.window)){
            self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
            self.addonController.deeplView.hidden = false;
            // try {
              // self.addonController.homePage('');
              
            // } catch (error) {
              
            // Application.sharedInstance().showHUD(error,self.window,2)
            // }
            self.addonController.minimized = false;
            self.addonController.miniMode = false
            if (self.addonController.dynamic) {
              self.customLayoutAddonController();
            }
            self.addonController.view.hidden = false;
            self.addonController.closeButton.hidden = false
            self.addonController.maxButton.hidden = false
            self.addonController.screenButton.hidden = false
            self.addonController.searchButton.hidden = false
            // Application.sharedInstance().showHUD(self.addonController.toolbarOn,self.window,2)

            if (self.addonController.toolbarOn) {
              self.addonController.engineButton.hidden = false
              self.addonController.goBackButton.hidden = false
              self.addonController.goForwardButton.hidden = false
              self.addonController.refreshButton.hidden = false
              self.addonController.opacityButton.hidden = false
              self.addonController.homeButton.hidden = false
            }else{
              self.addonController.engineButton.hidden = true
              self.addonController.goBackButton.hidden = true
              self.addonController.goForwardButton.hidden = true
              self.addonController.refreshButton.hidden = true
              self.addonController.opacityButton.hidden = true
              self.addonController.homeButton.hidden = true
            }
            textProcessed = true
            return; // Don't process message from other window
          } 
          if (!self.addonController.view.window) return;
          if (self.viewTimer) self.viewTimer.invalidate();
        // Application.sharedInstance().showHUD("123",self.window,2)
          var text = textSelected;
          if (text && text.length && !self.addonController.minimized && (Date.now()-dateGetText < 5000)) {
            // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
            self.addonController.search(text);
            // self.addonController.homePage(text);
            // self.customLayoutAddonController();
            if (self.addonController.dynamic) {
              self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
            }
            self.addonController.view.hidden = false;
            self.addonController.minimized = false;
            self.addonController.miniMode = false
            self.addonController.closeButton.hidden = false
            self.addonController.maxButton.hidden = false
            self.addonController.screenButton.hidden = false
            self.addonController.searchButton.hidden = false
            if (self.addonController.toolbarOn) {
              self.addonController.engineButton.hidden = false
              self.addonController.goBackButton.hidden = false
              self.addonController.goForwardButton.hidden = false
              self.addonController.refreshButton.hidden = false
              self.addonController.opacityButton.hidden = false
              self.addonController.homeButton.hidden = false
            }else{
              self.addonController.engineButton.hidden = true
              self.addonController.goBackButton.hidden = true
              self.addonController.goForwardButton.hidden = true
              self.addonController.refreshButton.hidden = true
              self.addonController.opacityButton.hidden = true
              self.addonController.homeButton.hidden = true
            }
            self.selectionText = text;
            textProcessed = true
          }else{
            textProcessed = true
            // self.addonController.homePage(text);
            // Application.sharedInstance().showHUD("No note or text selected",self.window,2)
            if (self.addonController.dynamic) {
              self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
            }
            self.addonController.view.hidden = false;
            self.addonController.minimized = false;
            self.addonController.miniMode = false
            self.addonController.closeButton.hidden = false
            self.addonController.maxButton.hidden = false
            self.addonController.screenButton.hidden = false
            self.addonController.searchButton.hidden = false
            if (self.addonController.toolbarOn) {
              self.addonController.engineButton.hidden = false
              self.addonController.goBackButton.hidden = false
              self.addonController.goForwardButton.hidden = false
              self.addonController.refreshButton.hidden = false
              self.addonController.opacityButton.hidden = false
              self.addonController.homeButton.hidden = false
            }else{
              self.addonController.engineButton.hidden = true
              self.addonController.goBackButton.hidden = true
              self.addonController.goForwardButton.hidden = true
              self.addonController.refreshButton.hidden = true
              self.addonController.opacityButton.hidden = true
              self.addonController.homeButton.hidden = true
            }
          }
      },
    },
    { /* Class members */
      addonDidConnect: function() {
      },

      addonWillDisconnect: function() {
      },

      applicationWillEnterForeground: function() {
      },

      applicationDidEnterBackground: function() {
      },

      applicationDidReceiveLocalNotification: function(notify) {
      }
    }
  );
  
  newAddonClass.prototype.hideViewIfTextChanged = function() {
    this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.1, true, () => {
      var currText = this.appInstance.studyController(this.window).readerController.currentDocumentController.selectionText;
      if (!currText || currText !== this.selectionText) {
        this.addonController.view.hidden = true;
        this.viewTimer.invalidate();
      }
    });
  };

  newAddonClass.prototype.layoutAddonController = function(rectStr, arrowNum,custom=false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
        w = (this.appInstance.osType !== 1) ? 400 : 365, // this.addonController.view.frame.width
        h = 500, // this.addonController.view.frame.height
        fontSize = 15,
        margin = 10,
        padding = 20,
        frame = this.appInstance.studyController(this.window).view.bounds,
        W = frame.width,
        H = frame.height,
        rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
        X = Number(rectArr[0]),
        Y = Number(rectArr[1]),
        studyMode = this.appInstance.studyController(this.window).studyMode,
        contextMenuWidth = studyMode === 0 ? 225 : 435,
        contextMenuHeight = 35,
        textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w/2 - margin <= 0) {
        x = margin;
      } else if (X + w/2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w/2;
      }
    } else {
      if (X - contextMenuWidth/2 - margin <= 0) {
        x = margin + contextMenuWidth/2 - w/2;
      } else if (X + contextMenuWidth/2 + margin >= W) {
        x = W - margin - contextMenuWidth/2 - w/2;
      } else {
        x = X - w/2;
      }
    }
    
    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
          lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
          lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h; 
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    // if (custom) {
    //     Application.sharedInstance().showHUD("custom",self.window,2)

    //   this.addonController.view.frame = {x:0,y:0,width:500,height:h-100};
    //   return
    // }
    this.addonController.view.frame = {x: x, y: y, width: w, height: h};
        // Application.sharedInstance().showHUD(this.addonController.view.frame,self.window,2)
  };
  newAddonClass.prototype.customLayoutAddonController = function(rectStr, arrowNum,custom=false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
        w = (this.appInstance.osType !== 1) ? 400 : 365, // this.addonController.view.frame.width
        h = 450, // this.addonController.view.frame.height
        fontSize = 15,
        margin = 10,
        padding = 20,
        frame = this.appInstance.studyController(this.window).view.bounds,
        W = frame.width,
        H = frame.height,
        rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
        X = Number(rectArr[0]),
        Y = Number(rectArr[1]),
        studyMode = this.appInstance.studyController(this.window).studyMode,
        contextMenuWidth = studyMode === 0 ? 225 : 435,
        contextMenuHeight = 35,
        textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w/2 - margin <= 0) {
        x = margin;
      } else if (X + w/2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w/2;
      }
    } else {
      if (X - contextMenuWidth/2 - margin <= 0) {
        x = margin + contextMenuWidth/2 - w/2;
      } else if (X + contextMenuWidth/2 + margin >= W) {
        x = W - margin - contextMenuWidth/2 - w/2;
      } else {
        x = X - w/2;
      }
    }
    
    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
          lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
          lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h; 
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    // if (custom) {
    //     Application.sharedInstance().showHUD("custom",self.window,2)

    //   this.addonController.view.frame = {x:0,y:0,width:500,height:h-100};
    //   return
    // }
    this.addonController.view.frame = {x: x, y: y+50, width: w, height: h};
        // Application.sharedInstance().showHUD(this.addonController.view.frame,self.window,2)
  };
  return newAddonClass;
};
